#include <stdio.h>

void quickSort(int arr[], int low, int high);
int getIndex(int arr[], int low, int high);

void quickSort(int arr[], int low, int high) {
    if (low < high) {
        int index = getIndex(arr, low, high); // 找寻基准数据的正确索引
        quickSort(arr, low, index - 1); // 对左半段排序
        quickSort(arr, index + 1, high); // 对右半段排序
    }
}

int getIndex(int arr[], int low, int high) {
    int tmp = arr[low]; // 基准数据
    while (low < high) {
        // 从左向右找到第一个大于基准的数据
        while (low < high && arr[low] <= tmp) {
            low++;
        }
        arr[high] = arr[low]; // 将大于基准的数据移到右侧

        // 从右向左找到第一个小于基准的数据
        while (low < high && arr[high] >= tmp) {
            high--;
        }
        arr[low] = arr[high]; // 将小于基准的数据移到左侧
    }
    arr[low] = tmp; // 将基准数据放到正确位置
    return low; // 返回基准数据的索引
}

int main() {
    int arr[] = { 1, 5, 8, 2, 0, -1, 6 };
    int n = sizeof(arr) / sizeof(arr[0]);
    quickSort(arr, 0, n - 1);    
    printf("排序后: ");
    for (int i = 0; i < n; i++)   
         printf("%d ", arr[i]);  
    printf("\n");
    return 0;
}
